
/**
 * Author:      Frdric Viela
 * Date:        2004
 *
 * AStar:	Andreas Jaggi
 */


import java.awt.Color;

/**
* Interface contenant toutes les contantes utilises dans le jeu
*/

public interface Constantes {
    /** OFFSET Taille d'un Block en pixels */
    final int OFFSET = 32;

    /** NBLIGNES Nombre de lignes d'un niveau */
    final int NBLIGNES = 13;
    
    /** NBCOLONNES Nombre de colonnes d'un niveau */
    final int NBCOLONNES = 19;

    /** LONGUEUR Longueur du Plateau en pixels */
    final int LONGUEUR = NBCOLONNES * OFFSET;
    
    /** LARGEUR Largeur du plateau en pixels */
    final int LARGEUR = NBLIGNES * OFFSET;

    /** HAUT Direction HAUT */
    final int HAUT = 0;
    /** BAS Direction BAS */
    final int BAS = 1;
    /** GAUCHE Direction GAUCHE */
    final int GAUCHE = 2;
    /** DROITE Direction DROITE */
    final int DROITE = 3;

    /** Puissance maximum des bombes */
    final int PUISSANCE_MAX = 8;

    /** NBCOUPES Nombre de victoires ncessaires pour changer de niveau */
    final int NBCOUPES = 2;

    /** tab[] Les couleurs des persos */
    /* original: static Color tab[] = {Color.cyan, Color.yellow};*/
    static Color tab[] = {Color.black, Color.white};


    /* constantes AStar (ajaggi) */

    /**
     * Couts d'un block intraversable
     */
    final double COUTS_INTRAVERSABLE = 1000.0;

    /**
     * Couts d'un block normal
     */
    final double COUTS_NORMAL = 1.0;

    /**
     * Couts d'un block contenant une bombe
     */
    final double COUTS_BOMBE = 1000.0;

    /**
     * Couts d'un block en voisinnage d'une bombe
     */
    final double COUTS_BOMBEVOISIN = 100.0;

    /**
     * Couts d'un block contenant un bonus
     */
    final double COUTS_BONUS = 0.1;

    /**
     * Couts d'un block contenant un malus
     */
    final double COUTS_MALUS = 5.0;

    /**
     * DEBUG-Flag, fait que quelques messages sont envoye au stdout
     */
    final boolean DEBUG = false;
}
