package bombmapper;

import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

/** Commande pour changer le terrain  une position spcifique dans
 * la table des blocs.
 * @author Sebastian Gfeller, Andreas Jaggi
 * @created Jun 16, 2004
 * @version ChangeTerrainEdit.java,v 1.1 2004/06/16 20:31:05 sgfeller Exp
 * @copyright Sebastian Gfeller, Andreas Jaggi 2004
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
public class ChangeTerrainEdit extends AbstractUndoableEdit {
	private Block bloc;
	private int typeTerrain;
	private int typeOriginal;

	/** Change le terrain du bloc
	 * On store la valeur original du type et la valeur nouveau,
	 * toutes deux dans cette instance. Alors on peut changer l'objet
	 *  son ancien type (undo) ou  son nouveau type (redo)
	 * sans problmes.
	 */
	public ChangeTerrainEdit(Block bloc, int typeTerrain) {
		super();
		this.bloc = bloc;
		this.typeTerrain = typeTerrain;
		typeOriginal = bloc.getType(); // on store le type original
		bloc.setType(typeTerrain);
	}

	public void undo() throws CannotUndoException {
		bloc.setType(typeOriginal);
	}
	
	public void redo() throws CannotRedoException {
		bloc.setType(typeTerrain);
	}
	
	public boolean canUndo() { return true; }
	public boolean canRedo() { return true; }
	public String getPresentationName() { return "Change Terrain"; }
}
