package bombmapper;

import java.io.File;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

/**
 * @author Sebastian Gfeller, Andreas Jaggi
 * @created Jun 18, 2004
 * @version DialogOuvrirSauvregarder.java,v 1.2 2004/06/27 16:28:26 sgfeller Exp
 * @copyright Sebastian Gfeller, Andreas Jaggi 2004
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
// pardonnez l'ignorance d'un tudiant suisse-allemand qui a crit 'sauvregarder' au lieu de 'enregistrer'
public class DialogOuvrirSauvregarder {
	private String filename;
	private String fichierSelectione;

	/** Cre un dialogue pour ouvrir ou enregistrer
	 * @param dEnregistrer On ouvre une fentre pour enregistrer si c'est true, autrement une pour ouvrir un fichier.
	 * @throws IOException
	 */
	public DialogOuvrirSauvregarder(boolean dEnregistrer, String filename) throws IOException {
		super();
		this.filename = filename;
		JFileChooser fc = new JFileChooser(new File(filename));
		
		if(dEnregistrer) {
			fc.showSaveDialog(new JFrame());
			fichierSelectione = fc.getSelectedFile().getCanonicalPath();
		} else {
			fc.showOpenDialog(new JFrame());
			fichierSelectione = fc.getSelectedFile().getCanonicalPath();
		}
	}

	/** Ca nous donne le chemin du fichier selectione.
	 * @return Le chemin du fichier+le nom
	 */
	public String getFichierSelectione() {
		return fichierSelectione;
	}
}
