package bombmapper;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/** Un filtre qui accepte seulement les fichiers du type level
 * @author Sebastian Gfeller, Andreas Jaggi
 * @created Jun 23, 2004
 * @version FiltreFichiersCarte.java,v 1.1 2004/06/23 20:37:19 sgfeller Exp
 * @copyright Sebastian Gfeller, Andreas Jaggi 2004
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
public class FiltreFichiersCarte extends FileFilter {
	/** Accepte des repertoires et des fichiers qui finissent avec ".lvl" */
	public boolean accept(File f) {
		boolean ret = false;
		if(f.isDirectory()) { ret = true; };
		if(f.getName().toLowerCase().endsWith(".lvl")) {
			ret = true;
		}
		return ret;
	}

	public String getDescription() {
		return "Fichiers carte";
	}

}
