package bombmapper;

/**
 * @author Sebastian Gfeller, Andreas Jaggi
 * @created Jun 15, 2004
 * @version Level.java,v 1.11 2004/06/23 20:37:18 sgfeller Exp
 * @copyright Sebastian Gfeller, Andreas Jaggi 2004
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 */
public abstract class Level {
	// constantes gnrales
	final static int NBLIGNES = 19;
	final static int NBCOLONNES = 13;
	// types des blocs
	final static int BLOC_SOLIDE = 3;
	final static int BLOC_LIBRE = 0;
	
	// donnes propres a un level
	protected String levelname;
	protected Block[][] carte;
	
	/** Les fichiers "standard" pour les images.*/
	protected String[] nomFichier = {"fond/sol/fond.gif","fond/mou/rocheh.gif",
			"fond/mur/glacon2.gif","fond/indestructible/logo150.gif",
			"bonus/bonusflamme.gif","bonus/bonusbombe.gif",
			"bonus/bonustelec.gif","bonus/bonuslanceur.gif",
			"bonus/bonuscrane.gif","bonus/bonuspatin.gif"};
	protected int[][] type;
	
	/** On dfinit le nom du level, rien de plus
	 */
	public Level(String levelname) {
		super();
		this.levelname = levelname;
	}

	/** Retourne un String array avec les chemins des fichiers images
	 * utiliss dans ce level
	 * @return Chemins sur images du level
	 */
	public String[] getNomsFichiers() {
		return nomFichier;
	}
	
	/** Remplit la carte et l'array avec les types avec des
	 * valeurs dfauts.
	 */
	protected void remplirCarteValeursDefauts() {
		carte = new Block[NBCOLONNES][NBLIGNES];
		type  = new int[NBCOLONNES][NBLIGNES];
		for(int y=0;y<carte.length;y++) {
			for(int x=0;x<carte[y].length;x++) {
				if(x == 0 || y == 0 || x == (carte[y].length - 1)
						|| y == (carte.length - 1)) { // On se trouve au bord: Solide
					carte[y][x] = new Block(BLOC_SOLIDE);
				} else {
					carte[y][x] = new Block(BLOC_LIBRE);
				}
				type[y][x] = carte[y][x].getType();
			}
		}
	}
}
